/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//npm imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');
const channelModel = require('../../../schemas/channel/channelSchema');
const linkUtils = require('../../../utils/linkUtils');

module.exports.get = async function(req, res){
    try{
        //get validation error results
        const validResult = validationResult(req);

        //if they're empty
        if(validResult.isEmpty()){
            //Pull sanatized/validated input
            const data = matchedData(req);
            //Get the requested channel
            const chanDB = await channelModel.findOne({name: data.chanName});

            //If the requested channel doesn't exist
            if(chanDB == null){
                //ACK
                return errorHandler(res, "Channel not found.", "Bad Query");
            }

            //Return found channel's emotes
            res.status(200);
            return res.send(chanDB.getEmotes());
        }else{
            //otherwise scream
            res.status(400);
            return res.send({errors: validResult.array()})
        }
    }catch(err){
        return exceptionHandler(res, err);
    }
}

module.exports.post = async function(req, res){
    try{
        //get validation error results
        const validResult = validationResult(req);

        //if they're empty
        if(validResult.isEmpty()){
            //get matched data
            const {chanName, emoteName, link} = matchedData(req);
            //query for requested channel
            const chanDB = await channelModel.findOne({name: chanName});

            //If the requested channel doesn't exist
            if(chanDB == null){
                //ACK
                return errorHandler(res, "Channel not found.", "Bad Query");
            }

            //Filter emote list for...
            const foundEmotes = chanDB.emotes.filter((emote) => {
                //emotes with a name that matches emoteName
                return emote.name == emoteName;
            });

            //If we found one
            if(foundEmotes.length > 0){
                //ACK
                return errorHandler(res, "Emote already exists!");
            }

            //Initialize the emote object from linkUtils
            var emoteObj = await linkUtils.markLink(link);

            //If we didn't get a valid image/video file
            if(emoteObj.type != 'image' && emoteObj.type != 'video'){
                //AAAAAAAAAAAAAAAAAA
                return errorHandler(res, 'URL either does not lead to a valid image/video file, or leads to one that is larger than 4MB');
            }


            //Add the name to the emoteObj
            emoteObj.name = emoteName;

            //Push the newly created emote object into the channels emotes list
            chanDB.emotes.push(emoteObj);

            //Save the channel DB document
            chanDB.save();

            //Return the updated command list
            res.status(200);
            return res.send(chanDB.getEmotes());
        }else{
            //otherwise scream
            res.status(400);
            return res.send({errors: validResult.array()})
        }
    }catch(err){
        return exceptionHandler(res, err);
    }
}

module.exports.delete = async function(req, res){
    try{
        //get validation error results
        const validResult = validationResult(req);

        //if they're empty
        if(validResult.isEmpty()){
            //get matched data
            const {chanName, emoteName, link} = matchedData(req);
            //query for requested channel
            const chanDB = await channelModel.findOne({name: chanName});

            //If the requested channel doesn't exist
            if(chanDB == null){
                //ACK
                return errorHandler(res, "Channel not found.", "Bad Query");
            }

            //Filter emote list for...
            const foundEmotes = chanDB.emotes.filter((emote, emoteIndex) => {
                //If we find an emote that matches the emote name
                if(emote.name == emoteName){
                    //Splice out the emote
                    chanDB.emotes.splice(emoteIndex, 1);
                    //Return true to signify we found and deleted one
                    return true;
                }
            });

            //If didn't find one
            if(foundEmotes.length <= 0){
                //ACK
                return errorHandler(res, "Cannot delete non-existant emote!");
            }

            //Save the channel DB document
            chanDB.save();

            //Return the updated command list
            res.status(200);
            return res.send(chanDB.getEmotes());
        }else{
            //otherwise scream
            res.status(400);
            return res.send({errors: validResult.array()})
        }
    }catch(err){
        return exceptionHandler(res, err);
    }
}